package org.example;

import org.example.abilities.SpecialAbility;

// on pourra la modifier par la suite si des éléments ne conviennent pas
public abstract class Character {
    protected String name;
    protected int maxHP;
    protected int currentHP;
    protected int attackPower;
    protected int defense;
    protected SpecialAbility specialAbility;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getMaxHP() {
        return maxHP;
    }

    public void setMaxHP(int maxHP) {
        this.maxHP = maxHP;
    }

    public int getCurrentHP() {
        return currentHP;
    }

    public void setCurrentHP(int currentHP) {
        this.currentHP = currentHP;
    }

    public int getAttackPower() {
        return attackPower;
    }

    public void setAttackPower(int attackPower) {
        this.attackPower = attackPower;
    }

    public int getDefense() {
        return defense;
    }

    public void setDefense(int defense) {
        this.defense = defense;
    }


    public Character(String name, int maxHP, int attackPower, int defense) {
        this.name = name;
        this.maxHP = maxHP;
        this.currentHP = maxHP;
        this.attackPower = attackPower;
        this.defense = defense;
    }

    public boolean isAlive() {
        return currentHP > 0;
    }

    public void takeDamage(int damage) {
        int actualDamage = Math.max((int)(damage * (1 - Math.min(0.2 * defense, 0.8))), 0);
        currentHP = Math.max(currentHP - actualDamage, 0);
        System.out.println(name + " subit " + actualDamage + " dégâts. (PV restants : " + currentHP + ")");
    }

    public abstract void attack(Character target);

    public void useSpecialAbility(Character target) {
        if (specialAbility != null) {
            specialAbility.activate(this, target);
        }
    }
}
