package org.example;

import java.io.FileWriter;
import java.io.IOException;
import java.time.LocalDateTime;

public class Logger {
    private static Logger instance;
    private FileWriter writer;

    private Logger() {
        try {
            writer = new FileWriter("game_log.txt", true);
        } catch (IOException e) {
            System.out.println("Erreur lors de l'initialisation du logger : " + e.getMessage());
        }
    }

    public static Logger getInstance() {
        if (instance == null) {
            instance = new Logger();
        }
        return instance;
    }

    public void log(String message) {
        try {
            String timestamp = "[" + LocalDateTime.now() + "] ";
            writer.write(timestamp + message + "\n");
            writer.flush();
        } catch (IOException e) {
            System.out.println("Erreur lors de l'écriture dans le fichier de log : " + e.getMessage());
        }
    }
}
